using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using ZXDT.DBUtility;//Please add references

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Msg_NoticeInfo
    /// </summary>
    public partial class T_Msg_NoticeInfo
    {
        public T_Msg_NoticeInfo()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_NoticeId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Msg_NoticeInfo");
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_NoticeId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_Msg_NoticeInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Msg_NoticeInfo(");
            strSql.Append("F_CreateOn,F_CreateBy,F_CreateName,F_Code,F_Title,F_Resume,F_Content,F_ReceiveInfo,F_TypeId,F_TypeName,F_AlarmId,F_DeviceId,F_DeviceCode,F_DeviceName,F_ModifyBy,F_ModifyName,F_ModifyDate,F_State,F_AppState)");
            strSql.Append(" values (");
            strSql.Append("@F_CreateOn,@F_CreateBy,@F_CreateName,@F_Code,@F_Title,@F_Resume,@F_Content,@F_ReceiveInfo,@F_TypeId,@F_TypeName,@F_AlarmId,@F_DeviceId,@F_DeviceCode,@F_DeviceName,@F_ModifyBy,@F_ModifyName,@F_ModifyDate,@F_State,@F_AppState)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Code", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Resume", SqlDbType.NVarChar,800),
                    new SqlParameter("@F_Content", SqlDbType.Text),
                    new SqlParameter("@F_ReceiveInfo", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4),
                    new SqlParameter("@F_TypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AlarmId", SqlDbType.Int,4),
                    new SqlParameter("@F_DeviceId", SqlDbType.Int,4),
                    new SqlParameter("@F_DeviceCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeviceName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ModifyDate", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_AppState", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_CreateOn;
            parameters[1].Value = model.F_CreateBy;
            parameters[2].Value = model.F_CreateName;
            parameters[3].Value = model.F_Code;
            parameters[4].Value = model.F_Title;
            parameters[5].Value = model.F_Resume;
            parameters[6].Value = model.F_Content;
            parameters[7].Value = model.F_ReceiveInfo;
            parameters[8].Value = model.F_TypeId;
            parameters[9].Value = model.F_TypeName;
            parameters[10].Value = model.F_AlarmId;
            parameters[11].Value = model.F_DeviceId;
            parameters[12].Value = model.F_DeviceCode;
            parameters[13].Value = model.F_DeviceName;
            parameters[14].Value = model.F_ModifyBy;
            parameters[15].Value = model.F_ModifyName;
            parameters[16].Value = model.F_ModifyDate;
            parameters[17].Value = model.F_State;
            parameters[18].Value = model.F_AppState;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Msg_NoticeInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Msg_NoticeInfo set ");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_CreateName=@F_CreateName,");
            strSql.Append("F_Code=@F_Code,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Resume=@F_Resume,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_ReceiveInfo=@F_ReceiveInfo,");
            strSql.Append("F_TypeId=@F_TypeId,");
            strSql.Append("F_TypeName=@F_TypeName,");
            strSql.Append("F_AlarmId=@F_AlarmId,");
            strSql.Append("F_DeviceId=@F_DeviceId,");
            strSql.Append("F_DeviceCode=@F_DeviceCode,");
            strSql.Append("F_DeviceName=@F_DeviceName,");
            strSql.Append("F_ModifyBy=@F_ModifyBy,");
            strSql.Append("F_ModifyName=@F_ModifyName,");
            strSql.Append("F_ModifyDate=@F_ModifyDate,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_AppState=@F_AppState");
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Code", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Resume", SqlDbType.NVarChar,800),
                    new SqlParameter("@F_Content", SqlDbType.Text),
                    new SqlParameter("@F_ReceiveInfo", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4),
                    new SqlParameter("@F_TypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AlarmId", SqlDbType.Int,4),
                    new SqlParameter("@F_DeviceId", SqlDbType.Int,4),
                    new SqlParameter("@F_DeviceCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeviceName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ModifyDate", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_AppState", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CreateOn;
            parameters[1].Value = model.F_CreateBy;
            parameters[2].Value = model.F_CreateName;
            parameters[3].Value = model.F_Code;
            parameters[4].Value = model.F_Title;
            parameters[5].Value = model.F_Resume;
            parameters[6].Value = model.F_Content;
            parameters[7].Value = model.F_ReceiveInfo;
            parameters[8].Value = model.F_TypeId;
            parameters[9].Value = model.F_TypeName;
            parameters[10].Value = model.F_AlarmId;
            parameters[11].Value = model.F_DeviceId;
            parameters[12].Value = model.F_DeviceCode;
            parameters[13].Value = model.F_DeviceName;
            parameters[14].Value = model.F_ModifyBy;
            parameters[15].Value = model.F_ModifyName;
            parameters[16].Value = model.F_ModifyDate;
            parameters[17].Value = model.F_State;
            parameters[18].Value = model.F_AppState;
            parameters[19].Value = model.F_NoticeId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_NoticeId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Msg_NoticeInfo ");
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_NoticeId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_NoticeIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Msg_NoticeInfo ");
            strSql.Append(" where F_NoticeId in (" + F_NoticeIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Msg_NoticeInfo GetModel(int F_NoticeId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_NoticeId,F_CreateOn,F_CreateBy,F_CreateName,F_Code,F_Title,F_Resume,F_Content,F_ReceiveInfo,F_TypeId,F_TypeName,F_AlarmId,F_DeviceId,F_DeviceCode,F_DeviceName,F_ModifyBy,F_ModifyName,F_ModifyDate,F_State,F_AppState from T_Msg_NoticeInfo ");
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_NoticeId;

            ZXDT.CallCenter.Model.T_Msg_NoticeInfo model = new ZXDT.CallCenter.Model.T_Msg_NoticeInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Msg_NoticeInfo DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_Msg_NoticeInfo model = new ZXDT.CallCenter.Model.T_Msg_NoticeInfo();
            if (row != null)
            {
                if (row["F_NoticeId"] != null && row["F_NoticeId"].ToString() != "")
                {
                    model.F_NoticeId = int.Parse(row["F_NoticeId"].ToString());
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
                if (row["F_CreateName"] != null)
                {
                    model.F_CreateName = row["F_CreateName"].ToString();
                }
                if (row["F_Code"] != null)
                {
                    model.F_Code = row["F_Code"].ToString();
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Resume"] != null)
                {
                    model.F_Resume = row["F_Resume"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_ReceiveInfo"] != null)
                {
                    model.F_ReceiveInfo = row["F_ReceiveInfo"].ToString();
                }
                if (row["F_TypeId"] != null && row["F_TypeId"].ToString() != "")
                {
                    model.F_TypeId = int.Parse(row["F_TypeId"].ToString());
                }
                if (row["F_TypeName"] != null)
                {
                    model.F_TypeName = row["F_TypeName"].ToString();
                }
                if (row["F_AlarmId"] != null && row["F_AlarmId"].ToString() != "")
                {
                    model.F_AlarmId = int.Parse(row["F_AlarmId"].ToString());
                }
                if (row["F_DeviceId"] != null && row["F_DeviceId"].ToString() != "")
                {
                    model.F_DeviceId = int.Parse(row["F_DeviceId"].ToString());
                }
                if (row["F_DeviceCode"] != null)
                {
                    model.F_DeviceCode = row["F_DeviceCode"].ToString();
                }
                if (row["F_DeviceName"] != null)
                {
                    model.F_DeviceName = row["F_DeviceName"].ToString();
                }
                if (row["F_ModifyBy"] != null && row["F_ModifyBy"].ToString() != "")
                {
                    model.F_ModifyBy = int.Parse(row["F_ModifyBy"].ToString());
                }
                if (row["F_ModifyName"] != null)
                {
                    model.F_ModifyName = row["F_ModifyName"].ToString();
                }
                if (row["F_ModifyDate"] != null && row["F_ModifyDate"].ToString() != "")
                {
                    model.F_ModifyDate = DateTime.Parse(row["F_ModifyDate"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_AppState"] != null && row["F_AppState"].ToString() != "")
                {
                    model.F_AppState = int.Parse(row["F_AppState"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_NoticeId,F_CreateOn,F_CreateBy,F_CreateName,F_Code,F_Title,F_Resume,F_Content,F_ReceiveInfo,F_TypeId,F_TypeName,F_AlarmId,F_DeviceId,F_DeviceCode,F_DeviceName,F_ModifyBy,F_ModifyName,F_ModifyDate,F_State,F_AppState ");
            strSql.Append(" FROM T_Msg_NoticeInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_NoticeId,F_CreateOn,F_CreateBy,F_CreateName,F_Code,F_Title,F_Resume,F_Content,F_ReceiveInfo,F_TypeId,F_TypeName,F_AlarmId,F_DeviceId,F_DeviceCode,F_DeviceName,F_ModifyBy,F_ModifyName,F_ModifyDate,F_State,F_AppState ");
            strSql.Append(" FROM T_Msg_NoticeInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Msg_NoticeInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_NoticeId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Msg_NoticeInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Msg_NoticeInfo";
			parameters[1].Value = "F_NoticeId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod
        public bool UpdateNoticeState(Model.T_Msg_NoticeInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Msg_NoticeInfo set ");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_NoticeId=@F_NoticeId"); 
            SqlParameter[] parameters = {
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2), 
                      new SqlParameter("@F_NoticeId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_State;
            parameters[1].Value = model.F_NoticeId; 
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        #endregion  ExtensionMethod
    }
}


